#!/usr/bin/perl

$username="";
$password="";
$host="localhost";

#####
##### TESTS :
##### $database="tests_titux";
#####
##### WARNING :
$database="pitchouns";
#####

use DBI;
use vars qw($dbh);

sub titux_mysql_connect 
{
	$dbh ||= DBI->connect("DBI:mysql:database=$database;host=$host:port=3306", $username, $password);
}

sub titux_mysql_disconnect
{
	$dbh->disconnect; 
}

sub read_file
{
	print "read_file(): Reading data from @_[0]...\n";
	my $file_csv = @_[0];

	my $nom = "";
	my $prenom = "";
	my $adresse = "";
	my $adresse1 = "";
	my $adresse2 = "";
	my $adresse3 = "";
	my $cp = "";
	my $ville = "";
	my $tel = "";
	my $flag = 0;
	my $first_line = 0;
	my $id_client = 0;

	titux_mysql_connect();

	open(FILE, "<$file_csv");
	while (<FILE>) {
		@line = split(/\|/);
		my $code = @line[0];
		
		if ($code =~ /NOM/) {
			$nom = $line[2];
			$nom =~ s/"//g;
			$nom =~ s/'/\\'/g;
		}
		if ($code =~ /Pr.*nom/) {
			$prenom = @line[2];
			$prenom =~ s/"//g;
			$prenom =~ s/'/\\'/g;
		}
		if ($code =~ /phone/) {
			$tel = @line[2];
			$tel =~ s/"//g;
			$tel =~ s/'/\\'/g;
		}
		if ($code =~ /Adresse 1/) {
			$adresse1 = @line[2];
			$adresse1 =~ s/"//g;
			$adresse1 =~ s/'/\\'/g;
		}
		if ($code =~ /Adresse 2/) {
			$adresse2 = @line[2];
			$adresse2 =~ s/"//g;
			$adresse2 =~ s/'/\\'/g;
		}
		if ($code =~ /Adresse3/) {
			$adresse3 = @line[2];
			$adresse3 =~ s/"//g;
			$adresse3 =~ s/'/\\'/g;
		}

		if ($code =~ /Vdeur/) {
			$flag = 1;
			# print "Ok ligne de demarquation trouvee!\n";
			# print "$nom $prenom $adresse1 $adresse2 $adresse3 $cp $ville $tel\n";
		}
		if ($flag == 1) {
			if (!(@line[1] =~ /Code art/)) {
				if ($first_line == 0) {
#
# Je suis obligé de faire cela pour 
# avoir le code de la liste qui identifie les
# articles dans la table articles.
#
					$code_liste = @line[0];
					$code_liste =~ s/"//g;
					my $sSql = "INSERT INTO clients VALUES ('', '$nom', '$prenom', " .
						 "'$adresse1', '$adresse2', '$adresse3', '$tel', '$code_liste');"; 
					## print "$sSql\n";
					$first_line = 1;
					my $sth = $dbh->prepare($sSql);
				        my $Result = $sth->execute;

				        $sqlCommand = "SELECT cle_client FROM clients WHERE code_client='$code_liste';";
				        my $sth = $dbh->prepare($sqlCommand);
				        my $Result = $sth->execute;
	
        				my @row_ary  = $sth->fetchrow_array;
					$id_client = $row_ary[0];


					if ($#line != 6) {
						if ("X@line[0]" != "X") {
							print "[WARNING] liste $code_liste: probleme de retour-chariot.\n";
						} else {
							print ">>@line[0]<< @line[5]\n";
						}
					}
					if ("X@line[1]" ne "X") {
						my $code_a = @line[1];
						$code_a =~ s/"//g;

						my $desc_a = @line[2];
						$desc_a =~ s/"//g;
							$desc_a =~ s/\n/ /g;
							$desc_a =~ s/'/\\'/g;
							$desc_a =~ s/"//g;
							$desc_a =~ s/\n//g;
	
							$taille_a = @line[3];
							$taille_a =~ s/'/\\'/g;
							$taille_a =~ s/"//g;

							$prix_a = @line[4];
							$prix_a =~ s/,/\./g;
							$prix_a =~ s/"//g;
							$prix_a =~ s/ //g;
							$prix_a =~ s/€//g;
							
							$prix_decote_a = @line[5];
							$prix_decote_a =~ s/,/\./g;
							$prix_decote_a =~ s/"//g;
							$prix_decote_a =~ s/ //g;
							$prix_decote_a =~ s/€//g;

						my $s = "";
						if ("X$desc_a" ne "X") {
	
							if ("X$prix_decote_a" ne "X") {
								$s = "INSERT INTO articles VALUES ('$code_a','$desc_a','1', '$taille_a', '$prix_a', '1', '$prix_decote_a', '0', '0', '$id_client'  );";
							} else {
								$s = "INSERT INTO articles VALUES ('$code_a','$desc_a','1', '$taille_a', '$prix_a', '0', '0', '0', '0', '$id_client'  );";
							}
							## print "$s\n";
							my $sth = $dbh->prepare($s);
							my $Result = $sth->execute; 
						} 
					}
					
				} else {
					if ($#line != 6) {
						if ("X@line[0]" != "X") {
							print "[WARNING] liste $code_liste: probleme de retour-chariot. ($#line)\n";
						}
					}

					if ("X@line[1]" ne "X") {
						my $taille_a = "";
						my $prix_a = "";

						my $code_a = @line[1];
						$code_a =~ s/"//g;

						my $desc_a = @line[2];
						$desc_a =~ s/"//g;
							$desc_a =~ s/\n/ /g;
							$desc_a =~ s/'/\\'/g;
							$desc_a =~ s/"//g;
							$desc_a =~ s/\n//g;
	
							$taille_a = @line[3];
							$taille_a =~ s/'/\\'/g;
							$taille_a =~ s/"//g;

							$prix_a = @line[4];
							$prix_a =~ s/,/\./g;
							$prix_a =~ s/"//g;
							$prix_a =~ s/ //g;
							$prix_a =~ s/€//g;

							$prix_decote_a = @line[5];
							$prix_decote_a =~ s/,/\./g;
							$prix_decote_a =~ s/"//g;
							$prix_decote_a =~ s/ //g;
							$prix_decote_a =~ s/€//g;

						my $s = "";
						if ("X$desc_a" ne "X") {
							if ("X$prix_decote_a" ne "X") {
								$s = "INSERT INTO articles VALUES ('$code_a','$desc_a','1', '$taille_a', '$prix_a', '1', '$prix_decote_a', '0', '0', '$id_client'  );";
							} else {
								$s = "INSERT INTO articles VALUES ('$code_a','$desc_a','1', '$taille_a', '$prix_a', '0', '0', '0', '0', '$id_client'  );";
							}
							my $sth = $dbh->prepare($s);
							my $Result = $sth->execute; 
		
##							print "$s\n";
						}
					} 
				}
			}
		}
	}
	close FILE;
	## print "Bye!\n";
	titux_mysql_disconnect();
}

read_file($ARGV[0]);

exit;
